/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TikTokControllerActionDataLevelRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TikTokControllerActionDataLevelRequest{}

// TikTokControllerActionDataLevelRequest struct for TikTokControllerActionDataLevelRequest
type TikTokControllerActionDataLevelRequest struct {
	ReportType *string `json:"reportType,omitempty"`
}

// NewTikTokControllerActionDataLevelRequest instantiates a new TikTokControllerActionDataLevelRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTikTokControllerActionDataLevelRequest() *TikTokControllerActionDataLevelRequest {
	this := TikTokControllerActionDataLevelRequest{}
	return &this
}

// NewTikTokControllerActionDataLevelRequestWithDefaults instantiates a new TikTokControllerActionDataLevelRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTikTokControllerActionDataLevelRequestWithDefaults() *TikTokControllerActionDataLevelRequest {
	this := TikTokControllerActionDataLevelRequest{}
	return &this
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *TikTokControllerActionDataLevelRequest) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokControllerActionDataLevelRequest) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *TikTokControllerActionDataLevelRequest) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *TikTokControllerActionDataLevelRequest) SetReportType(v string) {
	o.ReportType = &v
}

func (o TikTokControllerActionDataLevelRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TikTokControllerActionDataLevelRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	return toSerialize, nil
}

type NullableTikTokControllerActionDataLevelRequest struct {
	value *TikTokControllerActionDataLevelRequest
	isSet bool
}

func (v NullableTikTokControllerActionDataLevelRequest) Get() *TikTokControllerActionDataLevelRequest {
	return v.value
}

func (v *NullableTikTokControllerActionDataLevelRequest) Set(val *TikTokControllerActionDataLevelRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTikTokControllerActionDataLevelRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTikTokControllerActionDataLevelRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTikTokControllerActionDataLevelRequest(val *TikTokControllerActionDataLevelRequest) *NullableTikTokControllerActionDataLevelRequest {
	return &NullableTikTokControllerActionDataLevelRequest{value: val, isSet: true}
}

func (v NullableTikTokControllerActionDataLevelRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTikTokControllerActionDataLevelRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
